-- Another wonderful Wrk production

Triggers = {}
Game.proper_item_accounting = true

function Triggers.init()
    for p in Players() do
        p._deaths = 0
        p._kills = 0
    end
end

function Triggers.idle()
    for p in Players() do
        if p.totally_dead and p.action_flags.action_trigger then
            p:revive()
            p.action_flags.action_trigger = false
            p._dead = false
        end
        local score = p._kills - p._deaths
        p.overlays[0].color = "yellow"
        p.overlays[1].color = "green"
        p.overlays[2].color = "red"
        p.overlays[3].color = "white"

        if score > 0 then
            p.overlays[0].text = "Score: +" .. score
        else
            p.overlays[0].text = "Score: " .. score
        end
        p.overlays[1].text = "Kills: " .. p._kills
        p.overlays[2].text = "Deaths: " .. p._deaths
        p.overlays[3].text = sec_to_time(Game.ticks / 30)
    end
end

function Triggers.player_damaged(victim, aggressor_player, aggressor_monster, damage_type, damage_amount, projectile)
    if victim.life < 0 then
        if not victim._dead then -- Just died
            victim._deaths = victim._deaths + 1
            victim._dead = true
        end
    end
end

function Triggers.monster_killed(monster, aggressor_player, projectile)
    if projectile and projectile.owner and projectile.owner.player then
        projectile.owner.player._kills = projectile.owner.player._kills + 1
    end
end

function sec_to_time(sec)
    local sec = tonumber(sec)
  
    if sec <= 0 then
      return "00:00:00";
    else
      hours = string.format("%02.f", math.floor(sec/3600));
      mins = string.format("%02.f", math.floor(sec/60 - (hours*60)));
      secs = string.format("%02.f", math.floor(sec - hours*3600 - mins *60));
      return hours..":"..mins..":"..secs
    end
  end